//*****************************************
// AVR Geiger Counter mega168 Program
// CPU Clock:1MHz
//   iq[Yf[^@WāAOIV[^(8MHz)ɂj
// KCK[JE^[vO
//
// File Name:a_d.c
//
//  2011/12/17 Taishi New
//  2012/ 3/23 Taishi Ver 1.30
//*****************************************

#include	<avr/io.h>
#include	<avr/eeprom.h>

#include	"ATmega168_geiger.h"
#include	"gei_eeprom.h"
#include	"utl.h"
#include	"glb_dat.h"
#include	"timer.h"
#include	"a_d.h"

// **********************************************************
// ************************* A/D 0 **************************
// **********************************************************
#define			N_of_AD_data		16						// Q̊K̒lɌ

static	unsigned int	ad0_data[N_of_AD_data];
static	unsigned char	ad0_count;
//*****************************************
// A/D 0 Initial
//*****************************************
void	ad0_init(void)
{
	unsigned char	i;

	PRR &= ~(1 << PRADC);																// ADC ғ
	delay_16us(100/16);																	// POOr҂

	DDRC &= ~(1 << DDC0);																// PC0:Input
	DIDR0 |= (1 << ADC0D);																// ADC0 ޼ٓ͋֎~

	ad0_count = 0;
	for(i = 0; i < N_of_AD_data; i++){
		ad0_data[i] = 0;
	}

	ADMUX = ( (1 << REFS1) | (1 << REFS0) );												// Int. REF 1.1V, Select ADC0
	ADCSRA = ( (1 << ADEN) | (1 << ADSC) | (1 << ADPS2) | (1 << ADPS1) | (1 << ADPS0) );	// A/D, A/DϊJn, CK/128=8MHz/128=62.5kHz(16uS) --> 208uS
	ad0_active = 1;
}

//*****************************************
// A/D 0 Close
//*****************************************
void	ad0_close(void)
{
	ad0_active = 0;

	PRR |= (1 << PRADC);																// ADC ~
	delay_16us(100/16);																	// POOr҂
}

//*****************************************
// A/D 0 Set A/D data to Data Buffer
//  ϊIĂȂ́@Ȃ
//*****************************************
void	ad0_set_data(void)
{
	if( (ADCSRA & (1 << ADIF)) != 0){						// `^cϊ
		ADCSRA |= (1 << ADIF);								// `^cϊtO폜
		ad0_data[ad0_count] = ADCW;
		ad0_count++;
		ad0_count &= (N_of_AD_data - 1);
		ADCSRA |= (1 << ADSC);								// A/DϊJn
	}
}
//*****************************************
// A/D 0 Get A/D data
//  obt@ɓĂf[^𕽋ςĎ擾
//*****************************************
unsigned int	ad0_get_data(void)
{
	unsigned char	i;
	unsigned int	sum;

	sum = 0;
	for(i = 0; i < N_of_AD_data; i++){						// obt@Sđ
		sum += ad0_data[i];
	}

	sum /= N_of_AD_data;									// f[^Ŋĕϒlɂ

	return(sum);
}
