//*****************************************
// AVR Geiger Counter mega168 Program
// CPU Clock:1MHz
//   iq[Yf[^@WāAOIV[^(8MHz)ɂj
// KCK[JE^[vO
//
// File Name:const_str.c
//
//  2011/12/17 Taishi New
//  2012/ 3/23 Taishi Ver 1.30
//  2012/ 7/ 7 Taishi Ver 1.31
//*****************************************

#include	<avr/pgmspace.h>

#include	"ATmega168_geiger.h"
#include	"const_str.h"

unsigned char	str_title_1[] PROGMEM      = {"Geiger 1MHz    "};	// ^Cg|P
unsigned char	str_title_2[] PROGMEM      = {"ATmega Ver 1.31"};	// ^Cg|Q
unsigned char	str_title_3[] PROGMEM      = {TITLE3};				// ^Cg|R
unsigned char	str_date[] PROGMEM         = {__DATE__};			// 쐬@N
unsigned char	str_time[] PROGMEM         = {__TIME__};			// 쐬@
unsigned char	str_cpm[] PROGMEM          = {"cpm "};				// "cpm"
unsigned char	str_cph[] PROGMEM          = {"cph"};				// "cph"
unsigned char	str_save_data[] PROGMEM    = {"No  cph  uSv/h"};	// "No  cph  uSv/h"
unsigned char	str_5minus[] PROGMEM       = {"-----"};				// "-----"
unsigned char	str_no_data[] PROGMEM      = {"Non Data !!"};		// "Non Data !!"
unsigned char	str_hv_wait[] PROGMEM      = {"HV Wait"};			// "HV Wait"
unsigned char	str_led_enable[] PROGMEM   = {"LED Enable     "};	// "LED Enable"
unsigned char	str_led_disable[] PROGMEM  = {"LED Disable    "};	// "LED Disable"
unsigned char	str_space10[] PROGMEM      = {"          "};		// "          "
unsigned char	str_adj[] PROGMEM          = {"Adj"};				// "Adj"
unsigned char	str_save_exit[] PROGMEM    = {"Save&Exit"};			// "Save&Exit
unsigned char	str_save_next[] PROGMEM    = {"Save&Next"};			// "Save&Next
unsigned char	str_ten8[] PROGMEM         = {"........"};			// "."

unsigned char	str_hv_out[] PROGMEM       = {"HV-Out"};			// "HV-Out"
unsigned char	str_cpm_to_uSv[] PROGMEM   = {"cpm->uSv"};			// "com->uSv"
unsigned char	str_per_h[] PROGMEM        = {"/h"};				// "/h"
unsigned char	str_uSv[] PROGMEM          = {"uSv"};				// "uSv"
unsigned char	str_span[] PROGMEM         = {"Span"};				// "Span"
unsigned char	str_offset[] PROGMEM       = {"Ofset"};				// "Ofset"

unsigned char	str_cr_lf[] PROGMEM        = {"\r\n"};				// CR+LF
unsigned char	str_5asta[] PROGMEM        = {"*****"};				// "*****"
unsigned char	str_average[] PROGMEM      = {"Ave."};				// "Ave. "

unsigned char	str_zero[] PROGMEM         = {"0"};					// "0"
unsigned char	str_dive[] PROGMEM         = {"/"};					// "/"
unsigned char	str_minus[] PROGMEM        = {"-"};					// "-"
unsigned char	str_asta[] PROGMEM         = {"*"};					// "*"
unsigned char	str_plus[] PROGMEM         = {"+"};					// "+"
unsigned char	str_colon[] PROGMEM        = {":"};					// ":"
unsigned char	str_sharp[] PROGMEM        = {"#"};					// "#"
unsigned char	str_comma[] PROGMEM        = {","};					// ","
unsigned char	str_volt[] PROGMEM         = {"V"};					// "V"

unsigned char	str_bat_loss[] PROGMEM     = {"\x01\x02"};			// drȂiGj lcd.c lcd_cg_data[]ƑΉĂKv
unsigned char	str_bat_low[] PROGMEM      = {"\x01\x06"};			// driGj   lcd.c lcd_cg_data[]ƑΉĂKv
unsigned char	str_bat_mid[] PROGMEM      = {"\x01\x05"};			// driGj   lcd.c lcd_cg_data[]ƑΉĂKv
unsigned char	str_bat_high[] PROGMEM     = {"\x04\x05"};			// driGj   lcd.c lcd_cg_data[]ƑΉĂKv
unsigned char	str_proces[] PROGMEM       = {"Process Select"};	// "Process Select"
unsigned char	str_disp[] PROGMEM         = {"Disp"};				// "Disp"
unsigned char	str_trans[] PROGMEM        = {"Trans"};				// "Trans"
unsigned char	str_erase[] PROGMEM        = {"Erase"};				// "Erase"
unsigned char	str_done[] PROGMEM         = {"Done !"};			// "Done !"
unsigned char	str_data[] PROGMEM         = {"Data"};				// "Data"
unsigned char	str_led[] PROGMEM          = {"LED"};				// "LED"
unsigned char	str_config[] PROGMEM       = {"Config"};			// "Config"
unsigned char	str_savedata[] PROGMEM     = {"SaveData"};			// "SaveData"
unsigned char	str_enable[] PROGMEM       = {"Enable"};			// "Enable"
unsigned char	str_disable[] PROGMEM      = {"Disable"};			// "Disable"
unsigned char	str_transmit[] PROGMEM     = {"Transmit"};			// "Transmit"
unsigned char	str_makedate[] PROGMEM     = {"Make Date: "};		// "Make Date: "
unsigned char	str_display[] PROGMEM      = {"Display"};			// "Display"
unsigned char	str_lamp[] PROGMEM         = {"\x03"};				// kdciGj
unsigned char	str_eep_save[] PROGMEM     = {"EepSave"};			// "EEP Save"
unsigned char	str_cpm_one_cycl[] PROGMEM = {"Cpm One Cycle"};		// "Cpm One Cycle"
unsigned char	str_cph_one_cycl[] PROGMEM = {"Cph One Cycle"};		// "Cph One Cycle"
unsigned char	str_cpm_endless[] PROGMEM  = {"Cpm Endless  "};		// "Cpm Endless"
unsigned char	str_cph_endless[] PROGMEM  = {"Cph Endless  "};		// "Cph Endless"
unsigned char	str_off[] PROGMEM          = {"OFF"};				// "OFF"
unsigned char	str_mode[] PROGMEM         = {"Mode"};				// "Mode"
unsigned char	str_change[] PROGMEM       = {"Change"};			// "Change"
unsigned char	str_cancel[] PROGMEM       = {"Cancel"};			// "Cancel"
unsigned char	str_eep[] PROGMEM          = {"EEP"};				// "EEP"

unsigned char	disp_moji[17];

//*****************************************
// vÖ̕擾
// 	őPU܂
//  擾 disp_moji[] ɓ
//*****************************************
void	get_pgm_str(unsigned char *puc)
{
	unsigned char i;
	unsigned char uc;

	for(i=0; i < 16 ; i++){
		uc = pgm_read_byte(puc + i);
		if(uc == 0){									// ^[~l[^[̎
			break;
		}
		disp_moji[i] = pgm_read_byte(puc + i);
	}
	disp_moji[i] = 0;
}
