//*****************************************
// AVR Geiger Counter mega168 Program
// CPU Clock:1MHz
//   iq[Yf[^@WāAOIV[^(8MHz)ɂj
// KCK[JE^[vO
//
// File Name:display.c
//
//  2011/12/17 Taishi New
//  2012/ 3/23 Taishi Ver 1.30
//*****************************************
#include	<avr/pgmspace.h>
#include	<avr/eeprom.h>

#include	"ATmega168_geiger.h"
#include	"const_str.h"
#include	"gei_eeprom.h"
#include	"lcd.h"
#include	"utl.h"
#include	"glb_dat.h"
#include	"a_d.h"
#include	"port_bit.h"
#include	"timer.h"
#include	"uart.h"
#include	"display.h"


//*****************************************
// rZiPԖ͂PԂ̃JEgɂj
//  FJEgli@́@j
//  QF1:PԒl@́@0:PԒl
//  0.00 <--> 9.99
//*****************************************
void	calcu_uSv_at_count(unsigned int cp, unsigned char minute_data)
{
	unsigned long	ul;

	if(minute_data == 1){								// f[^̎
		ul = (((unsigned long)cp * (unsigned long)1000) / (unsigned long)cpm_to_uSv_spn) - (unsigned long)cpm_to_uSv_ofs;	// 0.01PʂuSv
	}else{												// f[^̎
		ul = (((unsigned long)cp * (unsigned long)1000) / ((unsigned long)cpm_to_uSv_spn * (unsigned long)60))-(unsigned long)(cpm_to_uSv_ofs * 60);	// 0.01PʂuSv
	}
	if(0x80000000 <= ul){
		ul = (unsigned long)0;
	}
	if((unsigned long)999 < ul){
		ul = (unsigned long)999;
	}
	wtod_05u((char *)disp_moji,(unsigned int)ul);	// ɂ
	disp_moji[6] = disp_moji[5];
	disp_moji[5] = disp_moji[4];
	disp_moji[4] = disp_moji[3];
	disp_moji[3] = '.';
	if(disp_moji[1] == '0'){
		disp_moji[1] = ' ';
	}
	disp_moji[0] = ' ';
}
//*****************************************
// rZ\iPԂ̃JEgɂj
//  F\ʒu(0-->15)
//  Fs\ʒu(0-->1)
//  FJEgli@́@j
//  QF1:PԒl@́@0:PԒl
//  0.00 <--> 9.99
//*****************************************
void	disp_uSv_at_count(unsigned char x, unsigned char y, unsigned int cp, unsigned char minute_data)
{
	unsigned long	ul;

	get_pgm_str(&str_space10[0]);							// vÖ̕("      ")擾
	disp_lcd(x,y,&disp_moji[9]);							// \
	if(cp == 0xffff){										// f[^
		get_pgm_str(&str_5minus[0]);						// vÖ̕("-----")擾
		disp_lcd(x,y,&disp_moji[0]);						// \
	}else{
		if(minute_data == 1){								// f[^̎
			ul = (((unsigned long)cp * (unsigned long)1000) / (unsigned long)cpm_to_uSv_spn) - (unsigned long)cpm_to_uSv_ofs;	// 0.01PʂuSv
		}else{												// f[^̎
			ul = (((unsigned long)cp * (unsigned long)1000) / ((unsigned long)cpm_to_uSv_spn * (unsigned long)60))-(unsigned long)(cpm_to_uSv_ofs * 60);	// 0.01PʂuSv
		}
		if(0x80000000 <= ul){
			ul = (unsigned long)0;
		}
		if((unsigned long)999 < ul){
			ul = (unsigned long)999;
		}
		wtod_05u((char *)disp_moji,(unsigned int)ul);		// ɂ
		disp_moji[6] = disp_moji[5];
		disp_moji[5] = disp_moji[4];
		disp_moji[4] = disp_moji[3];
		disp_moji[3] = '.';
		disp_lcd(x, y, &disp_moji[2]);						// display LCD(16char x 2Line) Up or Down Side
	}
}

//*****************************************
// rZϕ\iPȂUObԂ̃JEgɂj
//  F\ʒu(0-->15)
//  Fs\ʒu(0-->1)
//  Foߕb(0-->59)
//	0.00 <--> 9.99
// 01234
//  1.23
//*****************************************
void	disp_average_60sec(unsigned char x, unsigned char y, unsigned char sec)
{
	unsigned long	ul;
	unsigned char	i;

	unsigned char	n=60;									// ςb
	unsigned char	num;
	unsigned int	ui;
	unsigned long	s=0;
	unsigned char	yuukou=0;
	unsigned char	s100=0;									// 1:POOȏ̎

	if(sec == 0){											// O̎
		num = 59;											// @O̔ԍ͂TX
	}else{
		num = sec - 1;										// xۑf[^̈Oɂ
	}

	for(i=0;i<n;i++){
		ui = sec_data[num];									// PƂ̃f[^
		if(ui == 0xffff){									// ̃f[^̎
			;
		}else{												// f[^LȎ
			s += (unsigned long)ui;							// 
			yuukou++;
		}
		if(num == 0){										// O̎
			num = 59;										// @O̔ԍ͂TX
		}else{
			num--;											// @Oɂ
		}
	}

	if(yuukou == 0){										// f[^
		get_pgm_str(&str_5minus[0]);						// vÖ̕("----")擾
		disp_lcd(x,y,&disp_moji[0]);						// \
	}else{
		if(100 <= s){
			s100 = 1;
		}
		if(yuukou != 60){
			s *= (unsigned long)60;
			s /= (unsigned long)yuukou;						// UObԂ̒lɊZ
		}
		ul = ((s * (unsigned long)1000) / (unsigned long)cpm_to_uSv_spn) - (unsigned long)cpm_to_uSv_ofs;	// 0.01PʂuSv
		if((unsigned long)0x80000000 <= ul){				// vZʂ}CiX̎
			ul = 0;
		}else if((unsigned long)999 < ul){					// vZʂ傫鎞
			ul = (unsigned long)999;
		}
		if(yuukou < n){										// ȃf[^L
			if(s100 == 1){									// ł@f[^POO𒴂
				get_pgm_str(&str_sharp[0]);					// "#"擾
				disp_lcd(x,y,&disp_moji[0]);				// \
			}else{
				get_pgm_str(&str_5asta[0]);					// vÖ̕("*****")擾
				disp_lcd(x,y,&disp_moji[4]);				// \
			}
		}else{
			get_pgm_str(&str_space10[0]);					// vÖ̕("          ")擾
			disp_lcd(x,y,&disp_moji[9]);					// \
		}

		wtod_05u((char *)disp_moji,(unsigned int)ul);		// ɂ
		disp_moji[6] = disp_moji[5];
		disp_moji[5] = disp_moji[4];
		disp_moji[4] = disp_moji[3];
		disp_moji[3] = '.';
		disp_lcd(x+1, y, &disp_moji[2]);					// display LCD(16char x 2Line) Up or Down Side
	}
}
//*****************************************
// rZϕ\iPȐ\Ԃ̃JEgɂj
//  F\ʒu(0-->15)
//  Fs\ʒu(0-->1)
//	0.00 <--> 9.99
// 012345678
// Ave. 1.23
//*****************************************
void	disp_average_few_min(unsigned char x, unsigned char y)
{
	unsigned long	ul;
	unsigned char	i;

															// ς镪
#ifdef		SI_22BG											// SI-22BG
	unsigned char	n=30;
#else		// SI_22BG
 #ifdef 	SI_29BG											// SI-29BG
	unsigned char	n=30;
 #else		// SI_29BG
	unsigned char	n=30;
 #endif		// SI_29BG
#endif		// SI_22BG

	unsigned char	num;
	unsigned int	ui;
	unsigned long	s=0;
	unsigned char	yuukou=0;
	unsigned char	s100=0;									// 1:POOȏ̎

	get_pgm_str(&str_average[0]);							// vÖ̕("Ave. ")擾
	disp_lcd(x,y,&disp_moji[0]);							// \

	num = ave_data_pos;										// xۑf[^̈Oɂ
	num--;
	num &= 0x3f;

	for(i=0;i<n;i++){
		ui = ave_data[num];									// PƂ̃f[^
		if(ui == 0xffff){									// ̃f[^̎
			;
		}else{												// f[^LȎ
			s += (unsigned long)ui;							// 
			yuukou++;
		}
		num--;												// Oɂ
		num &= 0x3f;
	}

	if(yuukou == 0){										// f[^
		get_pgm_str(&str_5minus[0]);						// vÖ̕("----")擾
		disp_lcd(x+4,y,&disp_moji[0]);						// \
	}else{
		if(100 <= s){
			s100 = 1;
		}
		s /= (unsigned long)yuukou;							// Pȕϒl
		ul = ((s * (unsigned long)1000) / (unsigned long)cpm_to_uSv_spn) - (unsigned long)cpm_to_uSv_ofs;	// 0.01PʂuSv
		if((unsigned long)0x80000000 <= ul){				// vZʂ}CiX̎
			ul = 0;
		}else if((unsigned long)999 < ul){					// vZʂ傫鎞
			ul = (unsigned long)999;
		}
		if(yuukou < n){										// ȃf[^L
			if(s100 == 1){									// ł@f[^POO𒴂
				get_pgm_str(&str_sharp[0]);					// "#"擾
				disp_lcd(x+4,y,&disp_moji[0]);				// \
			}else{
				get_pgm_str(&str_5asta[0]);					// vÖ̕("*****")擾
				disp_lcd(x+4,y,&disp_moji[4]);				// \
			}
		}else{
			get_pgm_str(&str_space10[0]);					// vÖ̕("          ")擾
			disp_lcd(x+4,y,&disp_moji[9]);					// \
		}

		wtod_05u((char *)disp_moji,(unsigned int)ul);		// ɂ
		disp_moji[6] = disp_moji[5];
		disp_moji[5] = disp_moji[4];
		disp_moji[4] = disp_moji[3];
		disp_moji[3] = '.';
		disp_lcd(x+5, y, &disp_moji[2]);					// display LCD(16char x 2Line) Up or Down Side
	}
}
//*****************************************
// gupo͒l̕\
//*****************************************
void	disp_hv_out(unsigned char x, unsigned char y)
{
	wtod_5u((char *)disp_moji,hv_out);						// High Volt Data
	disp_lcd(x, y, &disp_moji[2]);							// display LCD(16char x 2Line) Up or Down Side
}
//*****************************************
// ddoqnlۑf[^iPԖ͂PԂƁj̕\
// cph: 0=cpm Data, 1=cph Data
//*****************************************
static
void	disp_eep_save_data(void)
{
	unsigned short	i;
	unsigned short	n;
	unsigned char	esm;
	unsigned char	uc;
	unsigned int	ui;

	disp_clear();										// Clear Display
	get_pgm_str(&str_save_data[0]);						// PԖf[^̃^Cg擾
	disp_lcd(2,0,disp_moji);							// \
	n = N_of_SAVE_DATA;

	esm = read_save_data_from_EEP();						// SĂ̕ۑf[^̓ǂݏo
	if((esm == 1)||(esm == 3)){							// [cpm one cycle] or [cpm endless]
		get_pgm_str(&str_cpm[0]);						// "cpm"
		disp_lcd(6,0,disp_moji);						// \
	}else if(esm == 0){
		get_pgm_str(&str_space10[0]);					// "          "
		disp_lcd(6,0,&disp_moji[7]);					// \
	}
	wait_sw_off();										// Q̃XCb`Q@܂ŉiv[v

	if(esm == 0){										// ۑ
		get_pgm_str(&str_no_data[0]);					// vÖ̕("No Data !!")擾
		disp_lcd( 3,1,disp_moji);						// \
		delay_ms(2000);									// 2000mS Delay
	}else{												// ۑL鎞
		for(i=0;i<n;i++){
			wtod_5u((char *)(&disp_moji[0]), i+1);		// ԍ
			if(disp_moji[3]==' '){
				disp_moji[3]='-';
			}else if(disp_moji[2]==' '){
				disp_moji[2]='-';
			}else{
				disp_moji[1]='-';
			}
			disp_lcd(0, 1, &disp_moji[1]);				// display LCD(16char x 2Line) Down Side
			ui = eep_buf[i];
			if(ui == 0xffff){
				get_pgm_str(&str_5minus[0]);			// "-----"
				disp_lcd(5,1,disp_moji);				// \
				disp_lcd(11,1,&disp_moji[1]);			// \
			}else{
				wtod_5u((char *)disp_moji, ui);			// PԖ͂PԂƂ̃JEg
				disp_lcd(5, 1, &disp_moji[0]);			// display LCD(16char x 2Line) Down Side
				if((esm == 1)||(esm == 3)){				// [cpm one cycle] or [cpm endless]
					disp_uSv_at_count(11, 1, ui, 1);	// rZ\iPԂ̃JEgɂj
				}else{									// PԖf[^̎
					disp_uSv_at_count(11, 1, ui, 0);	// rZ\iPԂ̃JEgɂj
				}
			}
			while(1){
				uc = get_action_sw();					// XCb`Ԃ
				uc &= 0x0f;								// EXCb`ɂ
				if(uc != 0){							// ANVL鎞
					if(uc == SWR_OFF_SHORT){			// Zꂽ
						break;
					}else if(uc == SWR_OFF_LONG){		// ꂽ
						break;
					}
				}
			}
			if(uc == SWR_OFF_LONG){						// ꂽ
				break;
			}
		}
	}
}
//*****************************************
// ddoqnlۑf[^iPԖ͂PԂƁj̑M
//*****************************************
static
void	trans_eep_save_data(void)
{
	unsigned short	i;
	unsigned short	n;
	unsigned char	uc;
	unsigned int	ui;

	disp_clear();									// Clear Display
	uart_init();									// UART Initial
	get_pgm_str(&str_transmit[0]);					// "Transmit"
	disp_lcd(0,0,disp_moji);						// \

	get_pgm_str(&str_cr_lf[0]);						// CR LF
	uart_tx_str((char *)&disp_moji[0]);				// M

	get_pgm_str(&str_5minus[0]);					// "-----"
	for(i=0;i<8;i++){
		uart_tx_str((char *)&disp_moji[0]);			// M
	}
	get_pgm_str(&str_cr_lf[0]);						// CR LF
	uart_tx_str((char *)&disp_moji[0]);				// M

	get_pgm_str(&str_title_1[0]);					// "Geiger 1MHz"
	uart_tx_str((char *)&disp_moji[0]);				// M
	get_pgm_str(&str_title_3[1]);					// "  SI-????"
	disp_moji[9]=0;
	uart_tx_str((char *)&disp_moji[0]);				// M
	get_pgm_str(&str_title_2[0]);					// "ATmega Ver 1.30"
	uart_tx_str_crlf((char *)&disp_moji[6]);		// M

	get_pgm_str(&str_makedate[0]);					// "Make Date: "
	uart_tx_str((char *)&disp_moji[0]);				// M
	get_pgm_str(&str_date[0]);						// 쐬@N
	uart_tx_str((char *)&disp_moji[0]);				// M
	get_pgm_str(&str_space10[0]);					// "      "
	uart_tx_str((char *)&disp_moji[9]);				// M
	get_pgm_str(&str_time[0]);						// 쐬@
	uart_tx_str_crlf((char *)&disp_moji[0]);		// M

	get_pgm_str(&str_cpm_to_uSv[0]);				// 쐬@com->uSv
	uart_tx_str((char *)&disp_moji[0]);				// M
	get_pgm_str(&str_space10[0]);					// "      "
	uart_tx_str((char *)&disp_moji[9]);				// M
	get_pgm_str(&str_span[0]);						// "Span"
	uart_tx_str((char *)&disp_moji[0]);				// M
	get_pgm_str(&str_colon[0]);						// ":"
	uart_tx_str((char *)&disp_moji[0]);				// M
	wtod_05u((char *)disp_moji,cpm_to_uSv_spn);		// Z Data
	disp_moji[6] = disp_moji[5];
	disp_moji[5] = disp_moji[4];
	disp_moji[4] = '.';
	if(disp_moji[1] == '0'){
		disp_moji[1] = ' ';
		if(disp_moji[2] == '0'){
			disp_moji[2] = ' ';
		}
	}
	uart_tx_str((char *)&disp_moji[1]);				// M
	get_pgm_str(&str_comma[0]);						// ","
	uart_tx_str((char *)&disp_moji[0]);				// M
	get_pgm_str(&str_space10[0]);					// "      "
	uart_tx_str((char *)&disp_moji[9]);				// M
	get_pgm_str(&str_offset[0]);					// "Ofset"
	uart_tx_str((char *)&disp_moji[0]);				// M
	get_pgm_str(&str_colon[0]);						// ":"
	uart_tx_str((char *)&disp_moji[0]);				// M
	wtod_05u((char *)disp_moji,cpm_to_uSv_ofs);		// Z Data
	if(disp_moji[3] == '0'){
		disp_moji[3] = ' ';
	}
	uart_tx_str_crlf((char *)&disp_moji[3]);		// M

	get_pgm_str(&str_space10[0]);					// "      "
	uart_tx_str_crlf((char *)&disp_moji[9]);		// M

	get_pgm_str(&str_transmit[0]);					// "Transmit"
	uart_tx_str((char *)&disp_moji[0]);				// M
	get_pgm_str(&str_space10[0]);					// "      "
	uart_tx_str((char *)&disp_moji[9]);				// M
	get_pgm_str(&str_savedata[0]);					// "SaveData"
	uart_tx_str((char *)&disp_moji[0]);				// M
	get_pgm_str(&str_space10[0]);					// "      "
	uart_tx_str((char *)&disp_moji[9]);				// M

	uc = read_save_data_from_EEP();					// SĂ̕ۑf[^̓ǂݏo
	if((uc == 1)||(uc == 3)){						// [cpm one cycle] or [cpm endless]
		get_pgm_str(&str_cpm[0]);					// "cpm"
		disp_lcd(9,0,disp_moji);					// \
		if(uc == 1){								// [cpm one cycle] ̎
			get_pgm_str(&str_cpm_one_cycl[0]);		// "Cpm One Cycle"
		}else{
			get_pgm_str(&str_cpm_endless[0]);		// "Cpm Endless"
		}
		uart_tx_str_crlf((char *)&disp_moji[0]);	// M

		get_pgm_str(&str_space10[0]);				// "      "
		uart_tx_str((char *)&disp_moji[8]);			// M
		get_pgm_str(&str_save_data[0]);				// PԖf[^̃^Cg擾
		disp_moji[6]='m';
		uart_tx_str_crlf((char *)&disp_moji[0]);	// M

	}else if((uc == 2)||(uc == 4)){					// [cph one cycle] or [cph endless]
		get_pgm_str(&str_cph[0]);					// "cph"
		disp_lcd(9,0,disp_moji);					// \
		if(uc == 2){								// [cph one cycle] ̎
			get_pgm_str(&str_cph_one_cycl[0]);		// "Cph One Cycle"
		}else{
			get_pgm_str(&str_cph_endless[0]);		// "Cph Endless"
		}
		uart_tx_str_crlf((char *)&disp_moji[0]);	// M

		get_pgm_str(&str_space10[0]);				// "      "
		uart_tx_str((char *)&disp_moji[8]);			// M
		get_pgm_str(&str_save_data[0]);				// PԖf[^̃^Cg擾
		uart_tx_str_crlf((char *)&disp_moji[0]);	// M
	}
	n = N_of_SAVE_DATA;

	wait_sw_off();									// Q̃XCb`Q@܂ŉiv[v

	if(uc == 0){											// ۑ
		uart_tx_str_crlf("");								// M
		get_pgm_str(&str_no_data[0]);						// vÖ̕("No Data !!")擾
		disp_lcd( 3,1,disp_moji);							// \
		uart_tx_str_crlf((char *)&disp_moji[0]);			// M
	}else{													// ۑL鎞
		for(i=0;i<n;i++){
			wtod_5u((char *)(&disp_moji[0]), i+1);			// ԍ
			if(disp_moji[3]==' '){
				disp_moji[3]='-';
			}else if(disp_moji[2]==' '){
				disp_moji[2]='-';
			}else{
				disp_moji[1]='-';
			}
			uart_tx_str((char *)&disp_moji[1]);				// M
			ui = eep_buf[i];
			if(ui == 0xffff){
				get_pgm_str(&str_space10[0]);				// "      "
				uart_tx_str((char *)&disp_moji[9]);			// M
				get_pgm_str(&str_5minus[0]);				// "-----"
				uart_tx_str((char *)&disp_moji[1]);			// M
				get_pgm_str(&str_comma[0]);					// "      "
				uart_tx_str((char *)&disp_moji[0]);			// M
				get_pgm_str(&str_space10[0]);				// "      "
				uart_tx_str((char *)&disp_moji[8]);			// M
				get_pgm_str(&str_5minus[0]);				// "-----"
				uart_tx_str_crlf((char *)&disp_moji[1]);	// M
			}else{
				wtod_5u((char *)disp_moji, ui);				// PԖ͂PԂƂ̃JEg
				uart_tx_str((char *)&disp_moji[0]);			// M
				get_pgm_str(&str_comma[0]);					// ","
				uart_tx_str((char *)&disp_moji[0]);			// M
				if((uc == 1)||(uc == 3)){					// [cpm one cycle] or [cpm endless]
					calcu_uSv_at_count(ui, 1);				// rZiPԂ̃JEgɂj
				}else{										// PԖf[^̎
					calcu_uSv_at_count(ui, 0);				// rZiPԂ̃JEgɂj
				}
				uart_tx_str_crlf((char *)&disp_moji[0]);	// M
			}
		}
		get_pgm_str(&str_done[0]);							// vÖ̕("Done !")擾
		disp_lcd( 5,1,disp_moji);							// \

	}
	delay_ms(2000);											// 2000mS Delay
}
//*****************************************
// ddoqnlۑf[^̏mFM
//*****************************************
void	confirm_deletet_save_data(void)
{
	unsigned char	keta=0;								//0:LZ, 1:ύX
	unsigned char	kesu=1;
	unsigned char	uc;

	disp_clear();										// Clear Display
	get_pgm_str(&str_eep_save[0]);						// vÖ̕("EepSave")擾
	disp_lcd( 0,0,disp_moji);							// \
	get_pgm_str(&str_data[0]);							// vÖ̕("Data")擾
	disp_lcd( 8,0,disp_moji);							// \

	wait_key_off();										// Q̃XCb`Q@܂ŉiv[v

	get_pgm_str(&str_cancel[0]);						// vÖ̕("Cancel")擾
	disp_lcd( 0,1, &disp_moji[0]);						// \
	get_pgm_str(&str_erase[0]);							// vÖ̕("Erase")擾
	disp_lcd( 7,1,disp_moji);							// \

	tim_10ms_ad0 = 0;									// `^cOpPOrPʃ^C}[\Ԋuɗp
	while(1){
		if(tim_10ms_ad0 == 0){							// TOOr̕\i`^cOp^C}[pj
			tim_10ms_ad0 = 50;

			kesu ^= 1;									// ␳l̓_
			if(kesu == 0){								// _ł̓_̎
				get_pgm_str(&str_cancel[0]);			// vÖ̕("Cancel")擾
				disp_lcd( 0,1, &disp_moji[0]);			// \
				get_pgm_str(&str_erase[0]);				// vÖ̕("Erase")擾
				disp_lcd( 7,1,disp_moji);				// \
			}else{										// _ł̖ł̎
				get_pgm_str(&str_space10[0]);			// vÖ̕("      ")擾
				if(keta == 0){
					disp_lcd( 0,1, &disp_moji[4]);		// \
				}else{
					disp_lcd (7,1, &disp_moji[4]);		// \
				}
			}
		}
		uc = get_action_sw();							// XCb`Ԃ
		uc &= 0x0f;										// EXCb`ɂ
		if(uc != 0){									// ANVL鎞
			if(uc == SWR_OFF_SHORT){					// Zꂽ
				keta++;
				if(1 < keta){
					keta = 0;
				}
			}else if(uc == SWR_OFF_LONG){				// ꂽ
				if(keta == 0){							// LZ
					break;
				}else if(keta == 1){					// ύX
					get_pgm_str(&str_space10[0]);		// vÖ̕("      ")擾
					disp_lcd( 0,1, &disp_moji[4]);		// \
					delete_save_data_on_EEP();			// ۑf[^̑S
					get_pgm_str(&str_space10[0]);		// vÖ̕("      ")擾
					disp_lcd( 7,1, &disp_moji[4]);		// \
					get_pgm_str(&str_done[0]);			// vÖ̕("Done !")擾
					disp_lcd( 5,1,disp_moji);			// \
					delay_ms(2000);
					break;
				}
				kesu = 1;
			}
		}
	}
	wait_key_off();										// Q̃XCb`Q@܂ŉiv[v
}
//*****************************************
// ۑf[^̕\ or M@I
//*****************************************
void	proc_disp_trans(void)
{
	unsigned char	sel=0;										// 0:"Disp", 1:"Trans"
	unsigned char	kesu=1;
	unsigned char	uc;

	while(1){
		disp_clear();												// Clear Display
		get_pgm_str(&str_proces[0]);								// vÖ̕("Process Sel")擾
		disp_lcd( 0,0,disp_moji);									// \
		get_pgm_str(&str_disp[0]);									// vÖ̕("Disp")擾
		disp_lcd( 0,1,disp_moji);									// \
		get_pgm_str(&str_trans[0]);									// vÖ̕("Trans")擾
		disp_lcd( 5,1,disp_moji);									// \
		get_pgm_str(&str_erase[0]);									// vÖ̕("Erase")擾
		disp_lcd(11,1,disp_moji);									// \

		wait_key_off();												// Q̃XCb`Q@܂ŉiv[v

		tim_10ms_ad0 = 0;											// `^cOpPOrPʃ^C}[\Ԋuɗp
		while(1){
			if(tim_10ms_ad0 == 0){									// TOOr̕\i`^cOp^C}[pj
				tim_10ms_ad0 = 50;
				kesu ^= 1;											// I̓_
				if(kesu == 0){										// _ł̓_̎
					get_pgm_str(&str_disp[0]);						// vÖ̕("Disp")擾
					disp_lcd( 0,1,disp_moji);						// \
					get_pgm_str(&str_trans[0]);						// vÖ̕("Trans")擾
					disp_lcd( 5,1,disp_moji);						// \
					get_pgm_str(&str_erase[0]);						// vÖ̕("Erase")擾
					disp_lcd(11,1,disp_moji);						// \
				}else{												// _ł̖ł̎
					get_pgm_str(&str_space10[0]);					// vÖ̕("      ")擾
					if(sel == 0){
						disp_lcd(0,1, &disp_moji[6]);				// Xy[X\
						get_pgm_str(&str_trans[0]);					// vÖ̕("Trans")擾
						disp_lcd( 5,1,disp_moji);					// \
						get_pgm_str(&str_erase[0]);					// vÖ̕("Erase")擾
						disp_lcd(11,1,disp_moji);					// \
					}else if(sel == 1){
						disp_lcd(5,1, &disp_moji[5]);				// Xy[X\
						get_pgm_str(&str_disp[0]);					// vÖ̕("Disp")擾
						disp_lcd( 0,1,disp_moji);					// \
						get_pgm_str(&str_erase[0]);					// vÖ̕("Erase")擾
						disp_lcd(11,1,disp_moji);					// \
					}else{
						disp_lcd(11,1, &disp_moji[5]);				// Xy[X\
						get_pgm_str(&str_disp[0]);					// vÖ̕("Disp")擾
						disp_lcd( 0,1,disp_moji);					// \
						get_pgm_str(&str_trans[0]);					// vÖ̕("Trans")擾
						disp_lcd( 5,1,disp_moji);					// \
					}
				}
			}
			uc = get_action_sw();									// XCb`Ԃ
			uc &= 0x0f;												// EXCb`ɂ
			if(uc != 0){											// ANVL鎞
				if(uc == SWR_OFF_SHORT){							// Zꂽ
					sel++;
					if(2 < sel){
						sel = 0;
					}
				}else if(uc == SWR_OFF_LONG){						// ꂽ
					if(sel == 0){
						disp_eep_save_data();						// ddoqnlۑf[^iPԖ͂PԂƁj̕\
					}else if(sel == 1){
						trans_eep_save_data();						// ddoqnlۑf[^iPԖ͂PԂƁj̑M
					}else{
						confirm_deletet_save_data();				// ddoqnlۑf[^̏mFM
					}
					kesu = 1;
					break;
				}
			}
		}
	}
}
//*****************************************
// ^Cg\
//   mode:0 CA 1:ݒ or ۑf[^
//*****************************************
void	disp_title(unsigned char mode)
{
	disp_clear();												// Clear Display
	get_pgm_str(&str_title_1[0]);								// vÖ̕("Geiger Counter")擾
	disp_lcd(0, 0, disp_moji);									// display LCD(16char x 2Line) Up Side
	get_pgm_str(&str_title_2[0]);								// vÖ̕("AVR ATmega Verx.xx")擾
	disp_lcd(0, 1, disp_moji);									// display LCD(16char x 2Line) Down Side

	delay_ms(2000);												// 2000mS Delay
	disp_clear();												// Clear Display
	get_pgm_str(&str_title_2[0]);								// vÖ̕("AVR ATmega Verx.xx")擾
	disp_lcd(0, 0, disp_moji);									// display LCD(16char x 2Line) Down Side
	get_pgm_str(&str_title_3[0]);								// vÖ̕("AVR ATmega Verx.xx")擾
	disp_lcd(0, 1, disp_moji);									// display LCD(16char x 2Line) Down Side

	if(mode == 1){
		delay_ms(2000);											// 2000mS Delay
		disp_clear();											// Clear Display
		get_pgm_str(&str_date[0]);								// vÖ̕(N)擾
		disp_lcd(0,0,disp_moji);								// \
		get_pgm_str(&str_time[0]);								// vÖ̕()擾
		disp_lcd(0,1,disp_moji);								// \
	}

	delay_ms(2000);												// 2000mS Delay
	disp_clear();												// Clear Display
}

//*****************************************
// obel\
//*****************************************
void	disp_battery(void)
{
	if(BAT_AD_HIGH <= bat_ad){				// dȏ̎
		get_pgm_str(&str_bat_high[0]);		// driGj
	}else if(BAT_AD_MID <= bat_ad){			// dȏ̎
		get_pgm_str(&str_bat_mid[0]);		// driGj
	}else if(BAT_AD_LOW <= bat_ad){			// dȏ̎
		get_pgm_str(&str_bat_low[0]);		// driGj
	}else{
		get_pgm_str(&str_bat_loss[0]);		// drȂiGj
	}
	disp_lcd( 0, 1, &disp_moji[0]);			// display LCD(16char x 2Line) Down Side

}
