//*****************************************
// AVR Geiger Counter mega168 Program
// CPU Clock:1MHz
//   iq[Yf[^@WāAOIV[^(8MHz)ɂj
// KCK[JE^[vO
//
// File Name:eeprom.c
//
//  2011/12/17 Taishi New
//  2012/ 3/23 Taishi Ver 1.30
//  2012/ 7/ 7 Taishi Ver 1.31
//*****************************************

#include	<avr/interrupt.h>
#include	<avr/eeprom.h>

#include	"ATmega168_geiger.h"
#include	"glb_dat.h"
#include	"utl.h"
#include	"gei_eeprom.h"

unsigned int	eep_save_write_pos EEMEM ={0};																	// xۑ鎞́@ۑʒu
unsigned char	eep_save_cpm_cph EEMEM ={0};																	// ۑf[^̎ށi1:cpm One Cycle, 2:cph One cycle, 3:cpm Endless, 4:cph Endlessj
unsigned char	eep_eep_save_mode[3] EEMEM ={EEP_SAVE_DEFAULT,EEP_SAVE_DEFAULT,EEP_SAVE_DEFAULT};				// ۑf[^̎ށA@
unsigned char	eep_dumy[11] EEMEM;																				// _~[
unsigned char	eep_led_on[16] EEMEM = {LED_ON_DEFAULT,LED_ON_DEFAULT,LED_ON_DEFAULT};							// kdcgۂ
unsigned int	eep_hv_out[8] EEMEM = {HV_OUT_DEFAULT,HV_OUT_DEFAULT,HV_OUT_DEFAULT};							// o͒l
unsigned int	eep_cpm_to_uSv_spn[8] EEMEM = {Cpm_uSv_SPN_DEFAULT,Cpm_uSv_SPN_DEFAULT,Cpm_uSv_SPN_DEFAULT};	// cpm_to_uSv_spn ZlXp̂PO{(500:50.0)
unsigned int	eep_cpm_to_uSv_ofs[8] EEMEM = {Cpm_uSv_OFS_DEFAULT,Cpm_uSv_OFS_DEFAULT,Cpm_uSv_OFS_DEFAULT};	// cpm_to_uSv_ofs ZItZbg(JEgl炱̒l)

unsigned int	eep_save_data[N_of_SAVE_DATA] EEMEM = {															// JEglۑ
				0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,	// 0x0000
				0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,	// 0x0010
				0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,	// 0x0020
				0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,	// 0x0030
				0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,	// 0x0040
				0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,	// 0x0050
				0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,	// 0x0060
				0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,	// 0x0070
				};


//*****************************************
// kdcnm^nee̓ǂݏo
// @荞ݕs̏ԂŌĂ΂Ƃ
//*****************************************
static
void	load_led_on_off(void)
{
	unsigned char	i;
	unsigned char	uc;
	unsigned char	uc_dim[3];

	for(i=0;i<3;i++){
		eeprom_busy_wait();
		uc_dim[i] = eeprom_read_byte(&eep_led_on[i]);					// kdcgp
	}
	uc = tasuuketu_uc(uc_dim[0], uc_dim[1], uc_dim[2], LED_ON_DEFAULT);	// 
	if(1 < uc){
		uc = 0;
	}
	for(i=0;i<3;i++){
		if(uc != uc_dim[i]){
			eeprom_busy_wait();
			eeprom_write_byte(&eep_led_on[i], uc);						// lɂ
		}
	}

	led_on = uc;
}
//*****************************************
// kdcnm^nee̕ۑ
// @荞݉̏ԂŌĂ΂Ƃ
//*****************************************
void	save_led_on_off(void)
{
	unsigned char	i;

	cli();												// 荞ݕs
	for(i=0;i<3;i++){
		eeprom_busy_wait();
		eeprom_write_byte(&eep_led_on[i], led_on);		// 
	}
	sei();												// 荞݉
}
//*****************************************
// ddoqnlۑ[h̓ǂݏo
// @荞ݕs̏ԂŌĂ΂Ƃ
//*****************************************
static
void	load_eep_save_mode(void)
{
	unsigned char	i;
	unsigned char	uc;
	unsigned char	uc_dim[3];

	for(i=0;i<3;i++){
		eeprom_busy_wait();
		uc_dim[i] = eeprom_read_byte(&eep_eep_save_mode[i]);				// ddoqnlۑ[h
	}
	uc = tasuuketu_uc(uc_dim[0], uc_dim[1], uc_dim[2], EEP_SAVE_DEFAULT);	// 
	if(4 < uc){
		uc = 0;
	}
	for(i=0;i<3;i++){
		if(uc != uc_dim[i]){
			eeprom_busy_wait();
			eeprom_write_byte(&eep_eep_save_mode[i], uc);					// lɂ
		}
	}

	eep_save_mode = uc;
}
//*****************************************
// ddoqnlۑ[h̕ۑ
// @荞݉̏ԂŌĂ΂Ƃ
//*****************************************
void	save_eep_save_mode(void)
{
	unsigned char	i;

	cli();													// 荞ݕs
	for(i=0;i<3;i++){
		eeprom_busy_wait();
		eeprom_write_byte(&eep_eep_save_mode[i], led_on);	// 
	}
	sei();													// 荞݉
}
//*****************************************
// f[^̕ۑ
// @荞݉̏ԂŌĂ΂Ƃ
//*****************************************
void	save_data_to_EEP(unsigned int ui)
{
	unsigned short	pos;
	unsigned char	go=0;

	if(eep_save_mode == 0){										// ddoqnlۑsgp
		;
	}else{
		eeprom_busy_wait();
		pos = eeprom_read_word(&eep_save_write_pos);			// ۑʒu
		if(N_of_SAVE_DATA <= pos){								// ۑ̈𒴂Ă鎞
			if((eep_save_mode == 3)||(eep_save_mode == 4)){		// ddoqnlۑ[h Endless ̎
				pos = 0;										// ۑʒu擪ɖ߂
				go = 1;
			}
		}else{
			go = 1;
		}
	}

	if(go == 1){
		cli();													// 荞ݕs
		eeprom_busy_wait();
		eeprom_write_word(eep_save_data + pos, ui);				// f[^̕ۑ
		sei();													// 荞݉

		pos++;

		cli();													// 荞ݕs
		eeprom_busy_wait();
		eeprom_write_word(&eep_save_write_pos, pos);			// ̕ۑʒu
		sei();													// 荞݉

		eeprom_busy_wait();
		go = eeprom_read_byte(&eep_save_cpm_cph);				// ۑf[^̎
//		if((go == 1)||(go == 3)||(go == 3)||(go == 4)){			// ۑf[^̎ނɏĂ鎞
		if((go == 1)||(go == 2)||(go == 3)||(go == 4)){			// V1.31 ۑf[^̎ނɏĂ鎞
			;													// Ȃ
		}else{													// Ŗi܂ĂȂj
			cli();												// 荞ݕs
			eeprom_busy_wait();
			eeprom_write_byte(&eep_save_cpm_cph, eep_save_mode);	// ۑf[^̎ނ
			sei();												// 荞݉
		}
	}
}
//*****************************************
// SĂ̕ۑf[^̓ǂݏo
// @荞݉̏ԂŌĂ΂Ƃ
//   eep_buf[] ɓǂݏo
// ߂l 0:f[^@1:cpm one cycle data, 2:cph one cycle data 3:cpm endless data 4:cph endless data
//*****************************************
unsigned char	read_save_data_from_EEP(void)
{
	unsigned short	i;
	unsigned short	ui;
	short			pos;
	unsigned char	r=0;

	eeprom_busy_wait();
	pos = eeprom_read_word(&eep_save_write_pos);			// ̕ۑʒu
	if(pos < 0){											// ۑi̕ۑʒuj
		;
	}else if((N_of_SAVE_DATA + 1) < pos){					// ۑi̕ۑʒuj
		;
	}else if(pos == 0){										// ۑ
		;
	}else{
		for(i=0;i<N_of_SAVE_DATA;i++){
			pos--;
			if(pos < 0){
				pos = (N_of_SAVE_DATA - 1);
			}
			eeprom_busy_wait();
			ui = eeprom_read_word(eep_save_data + pos);		// PԖf[^̓ǂݏo
			eep_buf[i] = ui;								// obt@ɓ
		}
		eeprom_busy_wait();
		r = eeprom_read_byte(&eep_save_cpm_cph);			// ۑf[^̎
	}
	return(r);
}
//*****************************************
// ۑf[^̑S
// @荞݉̏ԂŌĂ΂Ƃ
//*****************************************
void	delete_save_data_on_EEP(void)
{
	unsigned short	us;

	cli();												// 荞ݕs
	eeprom_busy_wait();
	eeprom_write_word(&eep_save_write_pos, 0);			// ̕ۑʒu
	sei();												// 荞݉

	for(us = 0; us < N_of_SAVE_DATA; us++){
		cli();											// 荞ݕs
		eeprom_busy_wait();
		eeprom_write_word(eep_save_data + us, 0xffff);	// ۑf[^̂ONA
		sei();											// 荞݉
	}

	cli();												// 荞ݕs
	eeprom_busy_wait();
	eeprom_write_byte(&eep_save_cpm_cph, 0);			// ۑf[^̎ނNA
	sei();												// 荞݉
}

//*****************************************
// rZl̓ǂݏo
// @荞ݕsŌĂԂ
//*****************************************
void	load_cpm_to_uSv(void)
{
	unsigned char	i;
	unsigned int	i_dim[3];

	// ZlXp
	for(i=0;i<3;i++){
		eeprom_busy_wait();
		i_dim[i] = eeprom_read_word(&eep_cpm_to_uSv_spn[i]);			// rZl
	}

	cpm_to_uSv_spn = tasuuketu_ui(i_dim[0], i_dim[1], i_dim[2], Cpm_uSv_SPN_DEFAULT);	// 

	if(Cpm_uSv_SPN_MAX < cpm_to_uSv_spn){
		cpm_to_uSv_spn = Cpm_uSv_SPN_DEFAULT;
	}else if(cpm_to_uSv_spn < Cpm_uSv_SPN_MIN){
		cpm_to_uSv_spn = Cpm_uSv_SPN_DEFAULT;
	}

	for(i=0;i<3;i++){
		if(cpm_to_uSv_spn != i_dim[i]){
			eeprom_busy_wait();
			eeprom_write_word(&eep_cpm_to_uSv_spn[i],cpm_to_uSv_spn);	// rZl̕ۑ
		}
		eeprom_busy_wait();
	}


	// ZlItZbgilj
	for(i=0;i<3;i++){
		eeprom_busy_wait();
		i_dim[i] = eeprom_read_word(&eep_cpm_to_uSv_ofs[i]);			// rZl
	}

	cpm_to_uSv_ofs = tasuuketu_ui(i_dim[0], i_dim[1], i_dim[2], Cpm_uSv_OFS_DEFAULT);		// 

	if(Cpm_uSv_OFS_MAX < cpm_to_uSv_ofs){
		cpm_to_uSv_ofs = Cpm_uSv_OFS_DEFAULT;
	}

	for(i=0;i<3;i++){
		if(cpm_to_uSv_ofs != i_dim[i]){
			eeprom_busy_wait();
			eeprom_write_word(&eep_cpm_to_uSv_ofs[i],cpm_to_uSv_ofs);	// rZl̕ۑ
		}
		eeprom_busy_wait();
	}
}

//*****************************************
// rZliXpj̕ۑ
// @荞݉̏ԂŌĂ΂Ƃ
//*****************************************
void	save_usvh_spn(void)
{
	unsigned char	i;

	cli();													// 荞ݕs

	for(i=0;i<3;i++){
		eeprom_busy_wait();
		eeprom_write_word(&eep_cpm_to_uSv_spn[i],cpm_to_uSv_spn);		// rZl̕ۑ
	}

	eeprom_busy_wait();
	sei();													// 荞݉
}
//*****************************************
// rZliItZbgj̕ۑ
// @荞݉̏ԂŌĂ΂Ƃ
//*****************************************
void	save_usvh_ofs(void)
{
	unsigned char	i;

	cli();													// 荞ݕs

	for(i=0;i<3;i++){
		eeprom_busy_wait();
		eeprom_write_word(&eep_cpm_to_uSv_ofs[i],cpm_to_uSv_ofs);		// rZl̕ۑ
	}

	eeprom_busy_wait();
	sei();													// 荞݉
}
//*****************************************
// guo͒l̓ǂݏo
// @荞ݕs̏ԂŌĂ΂Ƃ
//*****************************************
void	load_hv_out(void)
{
	unsigned char	i;
	unsigned int	i_dim[3];

	for(i=0;i<3;i++){
		eeprom_busy_wait();
		i_dim[i] = eeprom_read_word(&eep_hv_out[i]);						// guo͒l
	}

	hv_out = tasuuketu_ui(i_dim[0], i_dim[1], i_dim[2], HV_OUT_DEFAULT);	// 

	if(HV_OUT_MAX < hv_out){												// ͈͊Oij̎
		hv_out = HV_OUT_DEFAULT;											// ftHglɂ
	}else if(hv_out < HV_OUT_MIN){											// ͈͊Oij̎
		hv_out = HV_OUT_DEFAULT;											// ftHglɂ
	}

	for(i=0;i<3;i++){
		if(hv_out != i_dim[i]){
			eeprom_busy_wait();
			eeprom_write_word(&eep_hv_out[i],hv_out);						// guo͒l̕ۑ
		}
		eeprom_busy_wait();
	}
}
//*****************************************
// gu@o͒l̕ۑ
// @荞݉̏ԂŌĂ΂Ƃ
//*****************************************
void	save_hv_out(void)
{
	unsigned char	t;

	cli();											// 荞ݕs

	for(t = 0; t < 3; t++){
		eeprom_busy_wait();
		eeprom_write_word(&eep_hv_out[t],hv_out);	// guo͒l̕ۑ
	}

	eeprom_busy_wait();
	sei();											// 荞݉
}

//*****************************************
// ۑݒl̓ǂݏo
//*****************************************
void	read_config(void)
{
	load_led_on_off();							// kdcnm^nee̓ǂݏo
	load_cpm_to_uSv();							// rZl̓ǂݏo
	load_hv_out();								// guo͒l̓ǂݏo
	load_eep_save_mode();						// ddoqnlۑ[h̓ǂݏo
}
