//*****************************************
// AVR Geiger Counter mega168 Program
// CPU Clock:1MHz
//   iq[Yf[^@WāAOIV[^(8MHz)ɂj
// KCK[JE^[vO
//
// File Name:port_bit.c
//
//  2011/12/17 Taishi New
//  2012/ 3/23 Taishi Ver 1.30
//*****************************************

#include	<avr/io.h>

#include	"ATmega168_geiger.h"
#include	"timer.h"
#include	"glb_dat.h"
#include	"port_bit.h"

//******************************
// LED ON/OFF
//  on_off : 1=ON, 0=OFF
// *****************************
void	led_on_off(unsigned char on_off)
{
	if(on_off == 0){
		PORTD &= ~(1 << PD5);		// LED OFF
	}else{
		PORTD |=  (1 << PD5);		// LED ON
	}
}

unsigned char	sw[4];							// SW[1] Ɍ݂̏ԁAĂ镨'1'̏ԁA SW[2] ɉꂽuԂ'1'̏ԁA SW[3] ɗꂽuԂ'1'̏
static	unsigned char	old_sw;
//***************************
//@XCb`Ԃ
// SW[1] Ɍ݂̏ԁAĂ镨'1'̏
// SW[2] ɉꂽuԂ'1'̏
//  Timer2 ̊荞݂gpĂԂKv
//***************************
void	get_sw(void)
{
	unsigned char	uc;

	if(tim_10ms_sw == 0){
		tim_10ms_sw = 3;									// ROrԊu
		uc = ((~PINB) & (SW_LEFT | SW_RIGHT));				// ]ăXCb`f[^擾
		if (old_sw == uc){									// OƓf[^̎
			sw[0] = sw[1];
			sw[1] = uc;
			sw[2] = ((sw[0] ^ sw[1]) & sw[1]);				// ꂽXCb`f[^
			sw[3] = ((sw[0] ^ sw[1]) & ~sw[1]);				// ꂽXCb`f[^
		}else{
			sw[2] = 0;
			sw[3] = 0;
		}
		old_sw = uc;										// Of[^ɓ
	}else{
		sw[2] = 0;
		sw[3] = 0;
	}
}

#define			TMR_LONG			100			// 10mSx100=1Sec ̎Ԗ͒ZԂƂ
#define			TMR_CONTIMUE		100			// 10mSx100=1Sec ꑱ@̊ԊuŁuSWR_ON_CONTINUEvɂȂ
#define			TML_LONG			100			// 10mSx100=1Sec ̎Ԗ͒ZԂƂ
#define			TML_CONTIMUE		100			// 10mSx100=1Sec ꑱ@̊ԊuŁuSWR_ON_CONTINUEvɂȂ
//***************************
//@XCb`Ԃ
// SW[1] Ɍ݂̏ԁAĂ镨'1'̏
// SW[2] ɉꂽuԂ'1'̏
//  Timer2 ̊荞݂gpĂԂKv
//***************************
unsigned char	get_action_sw(void)
{
	unsigned char	uc=0;

	get_sw();												//@XCb`Ԃ

	if((sw[2] & SW_RIGHT) != 0){							// EXCb`nm̏uԂ̎
		uc |= SWR_ON;
		tim_10ms_swr_continue = TMR_CONTIMUE;
		tim_10ms_swr_length = TMR_LONG;
	}else if((sw[1] & SW_RIGHT) != 0){						// EXCb`nm̎
		if(tim_10ms_swr_continue == 0){						// ꑱo^C~O̎
			uc |= SWR_ON_CONTINUE;
			tim_10ms_swr_continue = TMR_CONTIMUE;
		}
	}else if((sw[3] & SW_RIGHT) != 0){						// EXCb`ꂽuԂ̎
		if(tim_10ms_swr_length == 0){						// ꂽԂ
			uc |= SWR_OFF_LONG;
		}else{												// ꂽԂZ
			uc |= SWR_OFF_SHORT;
		}
		tim_10ms_swr_continue = 0;
		tim_10ms_swr_length = 0;
	}else if((sw[1] & SW_RIGHT) == 0){						// EXCb`nee̎
		tim_10ms_swr_continue = 0;
		tim_10ms_swr_length = 0;
	}

	if((sw[2] & SW_LEFT) != 0){								// XCb`nm̏uԂ̎
		uc |= SWL_ON;
		tim_10ms_swl_continue = TML_CONTIMUE;
		tim_10ms_swl_length = TML_LONG;
	}else if((sw[1] & SW_LEFT) != 0){						// XCb`nm̎
		if(tim_10ms_swl_continue == 0){						// ꑱo^C~O̎
			uc |= SWL_ON_CONTINUE;
			tim_10ms_swl_continue = TML_CONTIMUE;
		}
	}else if((sw[3] & SW_LEFT) != 0){						// XCb`ꂽuԂ̎
		if(tim_10ms_swl_length == 0){						// ꂽԂ
			uc |= SWL_OFF_LONG;
		}else{												// ꂽԂZ
			uc |= SWL_OFF_SHORT;
		}
		tim_10ms_swl_continue = 0;
		tim_10ms_swl_length = 0;
	}else if((sw[1] & SW_LEFT) == 0){						// XCb`nee̎
		tim_10ms_swl_continue = 0;
		tim_10ms_swl_length = 0;
	}

	return(uc);
}
//*****************************************
// Q̃XCb`Q@܂ŉiv[v
//  XCb`͂Ɋ荞݃^C}[gB
//  Timer2 ̊荞݂gpĂԂKv
//*****************************************
void	wait_key_off(void)
{
	while(1){											// ̂rv܂ő҂
		get_sw();										//@XCb`Ԃ
		if( (sw[1] & (SW_LEFT | SW_RIGHT)) == 0 ){		// ꂽ
			break;
		}
	}
}
//*****************************************
// Q̃XCb`Q@܂ŉiv[v
//  XCb`rbǵA`^Op^C}[Ɂ@荞݂͎gȂ
//  \tgEFA^C}[gp
//*****************************************
void	wait_sw_off(void)
{
	while(1){
		if((PINB & (SW_LEFT | SW_RIGHT)) == (SW_LEFT | SW_RIGHT)){
			delay_ms(100);												// 100mS Delay
			if((PINB & (SW_LEFT | SW_RIGHT)) == (SW_LEFT | SW_RIGHT)){
				break;													// {ɗꂽƂ
			}
		}
	}
}
