//*****************************************
// AVR Geiger Counter mega168 Program
// CPU Clock:1MHz
//   iq[Yf[^@WāAOIV[^(8MHz)ɂj
// KCK[JE^[vO
//
// File Name:pulse.c
//
//  2011/12/17 Taishi New
//  2012/ 3/23 Taishi Ver 1.30
//*****************************************

#include	<avr/interrupt.h>
#include	<avr/io.h>

#include	"ATmega168_geiger.h"
#include	"glb_dat.h"
#include	"pulse.h"

// **********************************************************
// *********************** Pulse Count **********************
// **********************************************************

//***************************
// Count Initial
//***************************
void	count_init(void)
{
	count_sec = 0;								// PbԖ̃JEg
	count_minute = 0;							// PԖ̃JEg
	count_hour = 0;								// PԖ̃JEg
	tim_10ms_led = 0;							// kdcpPOrPʃ^C}[
	EICRA = ( (1 << ISC11) | (1 << ISC10) );	// INT1 Rising Edge Interrupt
	EIMSK = (1 << INT1);						// INT1 Interrupt Enable

}
//***************************
// INT1 Interrupt
//  Start Bit Falling Edge Sence
//***************************
ISR (INT1_vect)
{
	count_sec++;									// Pb̃JEg
	if(count_sec == 0xffff){
		count_sec = 0xfffe;
	}

	count_minute++;									// P̃JEg
	if(count_minute == 0xffff){
		count_minute = 0xfffe;
	}

	count_hour++;									// PԖ̃JEg
	if(count_hour == 0xffff){
		count_hour = 0xfffe;
	}

	tim_10ms_led = 5;
}

