//*****************************************
// AVR Geiger Counter mega168 Program
// CPU Clock:1MHz
//   iq[Yf[^@WāAOIV[^(8MHz)ɂj
// KCK[JE^[vO
//
// File Name:settei.c
//
//  2011/12/17 Taishi New
//  2012/ 3/23 Taishi Ver 1.30
//*****************************************
#include	<avr/interrupt.h>
#include	<avr/io.h>
#include	<avr/pgmspace.h>
#include	<avr/eeprom.h>

#include	"ATmega168_geiger.h"
#include	"const_str.h"
#include	"port_bit.h"
#include	"timer.h"
#include	"a_d.h"
#include	"lcd.h"
#include	"glb_dat.h"
#include	"utl.h"
#include	"gei_eeprom.h"
#include	"display.h"
#include	"settei.h"


//*****************************************
// guo͒l
//*****************************************
static
void	proc_set_hv_out(void)
{
	unsigned char	keta=0;								//0:100̌, 1:10̌, 2:1̌
	unsigned char	kesu=1;
	unsigned char	uc;

	disp_clear();										// Clear Display
	get_pgm_str(&str_hv_out[0]);						// vÖ̕("HV-OUT")擾
	disp_lcd( 0,0,disp_moji);							// \
	get_pgm_str(&str_adj[0]);							// vÖ̕("Adj")擾
	disp_lcd( 8,0,disp_moji);							// \

	wait_key_off();										// Q̃XCb`Q@܂ŉiv[v

	Timer1_init();										// Timer1 Initial
	HV_on();

	tim_10ms_ad0 = 0;									// `^cOpPOrPʃ^C}[\Ԋuɗp
	while(1){
		if(tim_10ms_ad0 == 0){												// TOOr̕\i`^cOp^C}[pj
			tim_10ms_ad0 = 50;

			kesu ^= 1;														// o͒l̓_
			if(kesu == 0){													// _ł̓_̎
				wtod_05u((char *)disp_moji, hv_out);						// o Data
				disp_lcd( 1,1, &disp_moji[2]);								// \
				get_pgm_str(&str_save_exit[0]);								// vÖ̕("Save&Exit")擾
				disp_lcd( 5,1,disp_moji);									// \
			}else{															// _ł̖ł̎
				get_pgm_str(&str_space10[0]);								// vÖ̕("      ")擾
				if(keta != 3){
					disp_lcd(keta+1,1, &disp_moji[9]);						// Xy[X\
				}else{
					disp_lcd (5,1, disp_moji);								// \
				}
			}
		}

		uc = get_action_sw();												// XCb`Ԃ
		uc &= 0x0f;															// EXCb`ɂ
		if(uc != 0){														// ANVL鎞
			if(uc == SWR_OFF_SHORT){										// Zꂽ
				keta++;
				if(3 < keta){
					keta = 0;
				}
			}else if(uc == SWR_OFF_LONG){									// ꂽ
				if(keta == 3){												// Ȉꏊ
					save_hv_out();											// guo͒l̕ۑ
					break;
				}
			}else if(uc == SWR_ON_CONTINUE){								// ꑱ
				if(keta == 0){												// POǑ
					if( (hv_out/100) < (HV_OUT_MAX/100) ){					// POǑőlȉ̎
						hv_out += 100;
					}else{
						hv_out = (HV_OUT_MIN/100)+(hv_out % 100);
					}
				}else if(keta == 1){										// PǑ
					if( ((hv_out % 100)/10) != 9 ){							// PǑXȊO̎
						hv_out += 10;
					}else{
						hv_out = ((hv_out/100)*100)+(hv_out % 10);
					}
				}else if(keta == 2){										// P̌
					if( (hv_out % 10) != 9 ){								// P̌XȊO̎
						hv_out += 1;
					}else{
						hv_out = ((hv_out/10)*10);
					}
				}
				if(HV_OUT_MAX < hv_out){									// ͈͊Oij̎
					hv_out = HV_OUT_MAX;									// őlɂ
				}else if(hv_out < HV_OUT_MIN){								// ͈͊Oij̎
					hv_out = HV_OUT_MIN;									// ŏlɂ
				}
				set_Timer1_ontime();										// guo͕ύX

				wtod_05u((char *)disp_moji, hv_out);						// o͒l Data
				disp_lcd( 1,1, &disp_moji[2]);								// \
				kesu = 1;
			}
		}
	}

	HV_off();
	wait_key_off();										// Q̃XCb`Q@܂ŉiv[v
}

//*****************************************
// rZlXp 999.9
//*****************************************
static
void	proc_set_cpm_uSv_span(void)
{
	unsigned char	keta=0;								//0:1000̌, 1:100̌, 2:10̌, 3:1̌, 4:ۑ
	unsigned char	kesu=1;
	unsigned char	uc;

	disp_clear();										// Clear Display
	get_pgm_str(&str_cpm_to_uSv[0]);					// vÖ̕("cpm->uSv")擾
	disp_lcd( 0,0,disp_moji);							// \
	get_pgm_str(&str_per_h[0]);							// vÖ̕("/h")擾
	disp_lcd( 8,0,disp_moji);							// \
	get_pgm_str(&str_span[0]);							// vÖ̕("Span")擾
	disp_lcd(11,0,disp_moji);							// \

	wtod_05u((char *)disp_moji,cpm_to_uSv_spn);			// Z Data
	disp_moji[6] = disp_moji[5];
	disp_moji[5] = disp_moji[4];
	disp_moji[4] = '.';
	disp_lcd( 0,1, &disp_moji[1]);						// \

	wait_key_off();										// Q̃XCb`Q@܂ŉiv[v

	tim_10ms_ad0 = 0;									// `^cOpPOrPʃ^C}[\Ԋuɗp
	while(1){
		if(tim_10ms_ad0 == 0){												// TOOr̕\i`^cOp^C}[pj
			tim_10ms_ad0 = 50;

			kesu ^= 1;														// ␳l̓_
			if(kesu == 0){													// _ł̓_̎
				wtod_05u((char *)disp_moji,cpm_to_uSv_spn);					// Z Data
				disp_moji[6] = disp_moji[5];
				disp_moji[5] = disp_moji[4];
				disp_moji[4] = '.';
				disp_lcd( 0,1, &disp_moji[1]);								// \
				get_pgm_str(&str_save_next[0]);								// vÖ̕("Save&Next")擾
				disp_lcd( 6,1,disp_moji);									// \
			}else{															// _ł̖ł̎
				get_pgm_str(&str_space10[0]);								// vÖ̕("      ")擾
				if(keta <= 2){
					disp_lcd(keta,1, &disp_moji[9]);						// \
				}else if(keta != 4){
					disp_lcd(keta+1,1, &disp_moji[9]);						// \
				}else{
					disp_lcd (6,1, disp_moji);								// \
				}
			}
		}
		uc = get_action_sw();												// XCb`Ԃ
		uc &= 0x0f;															// EXCb`ɂ
		if(uc != 0){														// ANVL鎞
			if(uc == SWR_OFF_SHORT){										// Zꂽ
				keta++;
				if(4 < keta){
					keta = 0;
				}
			}else if(uc == SWR_OFF_LONG){									// ꂽ
				if(keta == 4){												// Ȉꏊ
					if(cpm_to_uSv_spn == 0){
						cpm_to_uSv_spn = 1;
					}
					save_usvh_spn();										// rZliXpj̕ۑ
					break;
				}
			}else if(uc == SWR_ON_CONTINUE){								// ꑱ
				if(keta == 0){												// POOǑ
					if( (cpm_to_uSv_spn /1000) < (Cpm_uSv_SPN_MAX/1000) ){	// POOǑőľ菬
						cpm_to_uSv_spn += 1000;
					}else{
						cpm_to_uSv_spn %= 1000;
					}
				}else if(keta == 1){										// POǑ
					if( ((cpm_to_uSv_spn % 1000)/100) != 9 ){				// POǑXȊO̎
						cpm_to_uSv_spn += 100;
					}else{
						cpm_to_uSv_spn = ((cpm_to_uSv_spn/1000)*1000)+(cpm_to_uSv_spn % 100);
					}
				}else if(keta == 2){										// PǑ
					if( ((cpm_to_uSv_spn % 100)/10) != 9 ){					// PǑXȊO̎
						cpm_to_uSv_spn += 10;
					}else{
						cpm_to_uSv_spn = ((cpm_to_uSv_spn/100)*100)+(cpm_to_uSv_spn % 10);
					}
				}else if(keta == 3){										// P̌
					if( (cpm_to_uSv_spn % 10) != 9 ){						// P̌XȊO̎
						cpm_to_uSv_spn += 1;
					}else{
						cpm_to_uSv_spn = ((cpm_to_uSv_spn/10)*10);
					}
				}
				if(Cpm_uSv_SPN_MAX < cpm_to_uSv_spn){						// ͈͊Oij̎
					cpm_to_uSv_spn = Cpm_uSv_SPN_MAX;						// őlɂ
				}else if(cpm_to_uSv_spn < Cpm_uSv_SPN_MIN){					// ͈͊Oij̎
					cpm_to_uSv_spn = Cpm_uSv_SPN_MIN;						// ŏlɂ
				}

				wtod_05u((char *)disp_moji,cpm_to_uSv_spn);					// Z Data
				disp_moji[6] = disp_moji[5];
				disp_moji[5] = disp_moji[4];
				disp_moji[4] = '.';
				disp_lcd( 0,1, &disp_moji[1]);								// \
				kesu = 1;
			}
		}
	}

	wait_key_off();										// Q̃XCb`Q@܂ŉiv[v
}
//*****************************************
// rZlItZbg 99
//*****************************************
static
void	proc_set_cpm_uSv_ofset(void)
{
	unsigned char	keta=0;								//0:10̌, 1:1̌, 2:ۑ
	unsigned char	kesu=1;
	unsigned char	uc;

	disp_clear();										// Clear Display
	get_pgm_str(&str_cpm_to_uSv[0]);					// vÖ̕("cpm->uSv")擾
	disp_lcd( 0,0,disp_moji);							// \
	get_pgm_str(&str_per_h[0]);							// vÖ̕("/h")擾
	disp_lcd( 8,0,disp_moji);							// \
	get_pgm_str(&str_offset[0]);						// vÖ̕("Offset")擾
	disp_lcd(11,0,disp_moji);							// \

	wtod_05u((char *)disp_moji,cpm_to_uSv_ofs);			// Z Data
	disp_lcd( 0,1, &disp_moji[3]);						// \

	wait_key_off();										// Q̃XCb`Q@܂ŉiv[v

	tim_10ms_ad0 = 0;									// `^cOpPOrPʃ^C}[\Ԋuɗp
	while(1){
		if(tim_10ms_ad0 == 0){												// TOOr̕\i`^cOp^C}[pj
			tim_10ms_ad0 = 50;

			kesu ^= 1;														// ␳l̓_
			if(kesu == 0){													// _ł̓_̎
				wtod_05u((char *)disp_moji,cpm_to_uSv_ofs);					// Z Data
				disp_lcd( 0,1, &disp_moji[3]);								// \
				get_pgm_str(&str_save_exit[0]);								// vÖ̕("Save&Exit")擾
				disp_lcd( 6,1,disp_moji);									// \
			}else{															// _ł̖ł̎
				get_pgm_str(&str_space10[0]);								// vÖ̕("      ")擾
				if(keta <= 1){
					disp_lcd(keta,1, &disp_moji[9]);						// \
				}else{
					disp_lcd (6,1, disp_moji);								// \
				}
			}
		}
		uc = get_action_sw();												// XCb`Ԃ
		uc &= 0x0f;															// EXCb`ɂ
		if(uc != 0){														// ANVL鎞
			if(uc == SWR_OFF_SHORT){										// Zꂽ
				keta++;
				if(2 < keta){
					keta = 0;
				}
			}else if(uc == SWR_OFF_LONG){									// ꂽ
				if(keta == 2){												// Ȉꏊ
					save_usvh_ofs();										// rZliItZbgj̕ۑ
					break;
				}
			}else if(uc == SWR_ON_CONTINUE){								// ꑱ
				if(keta == 0){												// PǑ
					if( (cpm_to_uSv_ofs /10) != 9 ){						// PǑXȊO̎
						cpm_to_uSv_ofs += 10;
					}else{
						cpm_to_uSv_ofs = (cpm_to_uSv_ofs % 10);
					}
				}else if(keta == 1){										// P̌
					if( (cpm_to_uSv_ofs % 10) != 9 ){						// P̌XȊO̎
						cpm_to_uSv_ofs += 1;
					}else{
						cpm_to_uSv_ofs = ((cpm_to_uSv_ofs/10)*10);
					}
				}
				if(Cpm_uSv_OFS_MAX < cpm_to_uSv_ofs){						// ͈͊Oij̎
					cpm_to_uSv_ofs = Cpm_uSv_OFS_MAX;						// őlɂ
				}
				wtod_05u((char *)disp_moji,cpm_to_uSv_ofs);					// Z Data
				disp_lcd( 0,1, &disp_moji[3]);								// \
				kesu = 1;
			}
		}
	}
	wait_key_off();															// Q̃XCb`Q@܂ŉiv[v
}
//*****************************************
// kdcnm^neeݒ
//*****************************************
static
void	led_ena_dis(void)
{
	unsigned char	sel=0;										// 0:"Config", 1:"SaveData"
	unsigned char	kesu=1;
	unsigned char	uc;

	disp_clear();												// Clear Display
	get_pgm_str(&str_led[0]);									// "LED"
	disp_lcd( 0,0,disp_moji);									// \
	get_pgm_str(&str_disable[0]);								// "Disable"
	disp_lcd( 0,1,disp_moji);									// \
	get_pgm_str(&str_enable[0]);								// "Enable"
	disp_lcd( 8,1,disp_moji);									// \

	wait_key_off();												// Q̃XCb`Q@܂ŉiv[v

	tim_10ms_ad0 = 0;											// `^cOpPOrPʃ^C}[\Ԋuɗp
	while(1){
		if(tim_10ms_ad0 == 0){									// TOOr̕\i`^cOp^C}[pj
			tim_10ms_ad0 = 50;
			kesu ^= 1;											// I̓_
			if(kesu == 0){										// _ł̓_̎
				get_pgm_str(&str_disable[0]);					// "Disable"
				disp_lcd( 0,1,disp_moji);						// \
				get_pgm_str(&str_enable[0]);					// "Enable"
				disp_lcd( 8,1,disp_moji);						// \
			}else{												// _ł̖ł̎
				get_pgm_str(&str_space10[0]);					// vÖ̕("      ")擾
				if(sel == 0){
					disp_lcd(0,1, &disp_moji[3]);				// Xy[X\
					get_pgm_str(&str_enable[0]);				// "Enable"
					disp_lcd( 8,1,disp_moji);					// \
				}else{
					disp_lcd(8,1, &disp_moji[4]);				// Xy[X\
					get_pgm_str(&str_disable[0]);					// "Disable"
					disp_lcd( 0,1,disp_moji);						// \
				}
			}
		}
		uc = get_action_sw();									// XCb`Ԃ
		uc &= 0x0f;												// EXCb`ɂ
		if(uc != 0){											// ANVL鎞
			if(uc == SWR_OFF_SHORT){							// Zꂽ
				sel++;
				if(1 < sel){
					sel = 0;
				}
			}else if(uc == SWR_OFF_LONG){						// ꂽ
				if(sel == 0){
					led_on = 0;									// kdc|nee
				}else{
					led_on = 1;									// kdc|nm
				}
				save_led_on_off();								// kdcnm^nee̕ۑ
				break;
			}
		}
	}
}
//*****************************************
// ddoqnlۑ[h̕ۑƃf[^NA
//*****************************************
static
void	claer_save_eep_save_mode(unsigned char esm)
{
	unsigned char	keta=0;								//0:LZ, 1:ύX
	unsigned char	kesu=1;
	unsigned char	uc;

	disp_clear();										// Clear Display
	get_pgm_str(&str_eep_save[0]);						// vÖ̕("EepSave")擾
	disp_lcd( 0,0,disp_moji);							// \
	get_pgm_str(&str_mode[0]);							// vÖ̕("Mode")擾
	disp_lcd( 8,0,disp_moji);							// \

	wait_key_off();										// Q̃XCb`Q@܂ŉiv[v

	get_pgm_str(&str_cancel[0]);						// vÖ̕("Cancel")擾
	disp_lcd( 0,1, &disp_moji[0]);						// \
	get_pgm_str(&str_change[0]);						// vÖ̕("Change")擾
	disp_lcd( 7,1,disp_moji);							// \

	tim_10ms_ad0 = 0;									// `^cOpPOrPʃ^C}[\Ԋuɗp
	while(1){
		if(tim_10ms_ad0 == 0){							// TOOr̕\i`^cOp^C}[pj
			tim_10ms_ad0 = 50;

			kesu ^= 1;									// ␳l̓_
			if(kesu == 0){								// _ł̓_̎
				get_pgm_str(&str_cancel[0]);			// vÖ̕("Cancel")擾
				disp_lcd( 0,1, &disp_moji[0]);			// \
				get_pgm_str(&str_change[0]);			// vÖ̕("Change")擾
				disp_lcd( 7,1,disp_moji);				// \
			}else{										// _ł̖ł̎
				get_pgm_str(&str_space10[0]);			// vÖ̕("      ")擾
				if(keta == 0){
					disp_lcd( 0,1, &disp_moji[4]);		// \
				}else{
					disp_lcd (7,1, &disp_moji[4]);		// \
				}
			}
		}
		uc = get_action_sw();							// XCb`Ԃ
		uc &= 0x0f;										// EXCb`ɂ
		if(uc != 0){									// ANVL鎞
			if(uc == SWR_OFF_SHORT){					// Zꂽ
				keta++;
				if(1 < keta){
					keta = 0;
				}
			}else if(uc == SWR_OFF_LONG){				// ꂽ
				if(keta == 0){							// LZ
					break;
				}else if(keta == 1){					// ύX
					delete_save_data_on_EEP();			// ۑf[^̑S
					eep_save_mode = esm;
					save_eep_save_mode();				// ddoqnlۑ[h̕ۑ
					break;
				}
				kesu = 1;
			}
		}
	}
	wait_key_off();										// Q̃XCb`Q@܂ŉiv[v

}

//*****************************************
// ddoqnlۑ[h̑I
//*****************************************
static
void	proc_set_eep_save_mode(void)
{
	unsigned char	keta=0;								//0:ۑ[h, 1:ۑ
	unsigned char	kesu=1;
	unsigned char	uc;
	unsigned char	esm;

	disp_clear();										// Clear Display
	get_pgm_str(&str_eep[0]);							// vÖ̕("EEP")擾
	disp_lcd( 0,0,disp_moji);							// \

	esm = eep_save_mode;
	if(esm == 1){										// 1:cpm One Cycle
		get_pgm_str(&str_cpm_one_cycl[0]);				// vÖ̕("Cpm One Cycle")擾
	}else if(esm == 2){									// 2:cph One cycle
		get_pgm_str(&str_cph_one_cycl[0]);				// vÖ̕("Cph One Cycle")擾
	}else if(esm == 3){									// 3:cpm Endless
		get_pgm_str(&str_cpm_endless[0]);				// vÖ̕("Cpm Endless")擾
	}else if(esm == 4){									// 4:cph Endless
		get_pgm_str(&str_cph_endless[0]);				// vÖ̕("Cph Endless")擾
	}else{
		get_pgm_str(&str_space10[0]);					// vÖ̕("      ")擾
		disp_lcd( 2,1, &disp_moji[0]);					// \
		get_pgm_str(&str_off[0]);						// vÖ̕("OFF")擾
	}
	disp_lcd( 0,1, &disp_moji[0]);						// \

	wait_key_off();										// Q̃XCb`Q@܂ŉiv[v

	tim_10ms_ad0 = 0;									// `^cOpPOrPʃ^C}[\Ԋuɗp
	while(1){
		if(tim_10ms_ad0 == 0){												// TOOr̕\i`^cOp^C}[pj
			tim_10ms_ad0 = 50;

			kesu ^= 1;														// ␳l̓_
			if(kesu == 0){													// _ł̓_̎
				if(esm == 1){												// 1:cpm One Cycle
					get_pgm_str(&str_cpm_one_cycl[0]);						// vÖ̕("Cpm One Cycle")擾
				}else if(esm == 2){											// 2:cph One cycle
					get_pgm_str(&str_cph_one_cycl[0]);						// vÖ̕("Cph One Cycle")擾
				}else if(esm == 3){											// 3:cpm Endless
					get_pgm_str(&str_cpm_endless[0]);						// vÖ̕("Cpm Endless")擾
				}else if(esm == 4){											// 4:cph Endless
					get_pgm_str(&str_cph_endless[0]);						// vÖ̕("Cph Endless")擾
				}else{
					get_pgm_str(&str_space10[0]);							// vÖ̕("      ")擾
					disp_lcd( 2,1, &disp_moji[0]);							// \
					get_pgm_str(&str_off[0]);								// vÖ̕("OFF")擾
				}
				disp_lcd( 0,1, &disp_moji[0]);								// \
				get_pgm_str(&str_save_exit[0]);								// vÖ̕("Save&Exit")擾
				disp_lcd( 4,0,disp_moji);									// \
			}else{															// _ł̖ł̎
				get_pgm_str(&str_space10[0]);								// vÖ̕("      ")擾
				if(keta == 0){
					disp_lcd( 0,1, &disp_moji[0]);							// \
					disp_lcd(10,1, &disp_moji[4]);							// \
				}else{
					disp_lcd (4,0, disp_moji);								// \
				}
			}
		}
		uc = get_action_sw();												// XCb`Ԃ
		uc &= 0x0f;															// EXCb`ɂ
		if(uc != 0){														// ANVL鎞
			if(uc == SWR_OFF_SHORT){										// Zꂽ
				keta++;
				if(1 < keta){
					keta = 0;
				}
			}else if(uc == SWR_OFF_LONG){									// ꂽ
				if(keta == 0){												// ۑ[h̏ꏊ
					esm++;
					if(4 < esm){
						esm = 0;
					}
				}else if(keta == 1){										// Ȉꏊ
					if(eep_save_mode != esm){
						claer_save_eep_save_mode(esm);						// ddoqnlۑ[h̕ۑƃf[^NA
					}
					break;
				}
				kesu = 1;
			}
		}
	}
	wait_key_off();															// Q̃XCb`Q@܂ŉiv[v

}

//*****************************************
// kdcAgu|ntsAor Zl̑I
//*****************************************
static
void	select_led_hv_cpm(void)
{
	unsigned char	sel=0;										// 0:"LED", 1:"HV-Out", 2:"cpm->uSv"
	unsigned char	kesu=1;
	unsigned char	uc;

	disp_clear();												// Clear Display
	get_pgm_str(&str_led[0]);									// vÖ̕("LED")擾
	disp_lcd( 0,0,disp_moji);									// \
	get_pgm_str(&str_hv_out[0]);								// vÖ̕("HV-Out")擾
	disp_lcd( 5,0,disp_moji);									// \
	get_pgm_str(&str_cpm_to_uSv[0]);							// vÖ̕("cpm->uSv")擾
	disp_lcd( 0,1,disp_moji);									// \
	get_pgm_str(&str_eep_save[0]);								// vÖ̕("EepSave")擾
	disp_lcd( 9,1,disp_moji);									// \

	wait_key_off();												// Q̃XCb`Q@܂ŉiv[v

	tim_10ms_ad0 = 0;											// `^cOpPOrPʃ^C}[\Ԋuɗp
	while(1){
		if(tim_10ms_ad0 == 0){									// TOOr̕\i`^cOp^C}[pj
			tim_10ms_ad0 = 50;
			kesu ^= 1;											// I̓_
			if(kesu == 0){										// _ł̓_̎
				get_pgm_str(&str_led[0]);						// vÖ̕("LED")擾
				disp_lcd( 0,0,disp_moji);						// \
				get_pgm_str(&str_hv_out[0]);					// vÖ̕("HV-Out")擾
				disp_lcd( 5,0,disp_moji);						// \
				get_pgm_str(&str_cpm_to_uSv[0]);				// vÖ̕("cpm->uSv")擾
				disp_lcd( 0,1,disp_moji);						// \
				get_pgm_str(&str_eep_save[0]);					// vÖ̕("EepSave")擾
				disp_lcd( 9,1,disp_moji);						// \
			}else{												// _ł̖ł̎
				get_pgm_str(&str_space10[0]);					// vÖ̕("      ")擾
				if(sel == 0){
					disp_lcd(0,0, &disp_moji[7]);				// Xy[X\
					get_pgm_str(&str_hv_out[0]);				// vÖ̕("HV-Out")擾
					disp_lcd( 5,0,disp_moji);					// \
					get_pgm_str(&str_cpm_to_uSv[0]);			// vÖ̕("cpm->uSv")擾
					disp_lcd( 0,1,disp_moji);					// \
					get_pgm_str(&str_eep_save[0]);				// vÖ̕("EepSave")擾
					disp_lcd( 9,1,disp_moji);					// \
				}else if(sel == 1){
					disp_lcd(5,0, &disp_moji[4]);				// Xy[X\
					get_pgm_str(&str_led[0]);					// vÖ̕("LED")擾
					disp_lcd( 0,0,disp_moji);					// \
					get_pgm_str(&str_cpm_to_uSv[0]);			// vÖ̕("cpm->uSv")擾
					disp_lcd( 0,1,disp_moji);					// \
					get_pgm_str(&str_eep_save[0]);				// vÖ̕("EepSave")擾
					disp_lcd( 9,1,disp_moji);					// \
				}else if(sel == 2){
					disp_lcd(0,1, &disp_moji[0]);				// Xy[X\
					get_pgm_str(&str_led[0]);					// vÖ̕("LED")擾
					disp_lcd( 0,0,disp_moji);					// \
					get_pgm_str(&str_hv_out[0]);				// vÖ̕("HV-Out")擾
					disp_lcd( 5,0,disp_moji);					// \
					get_pgm_str(&str_eep_save[0]);				// vÖ̕("EepSave")擾
					disp_lcd( 9,1,disp_moji);					// \
				}else{
					disp_lcd(9,1, &disp_moji[2]);				// Xy[X\
					get_pgm_str(&str_led[0]);					// vÖ̕("LED")擾
					disp_lcd( 0,0,disp_moji);					// \
					get_pgm_str(&str_hv_out[0]);				// vÖ̕("HV-Out")擾
					disp_lcd( 5,0,disp_moji);					// \
					get_pgm_str(&str_cpm_to_uSv[0]);			// vÖ̕("cpm->uSv")擾
					disp_lcd( 0,1,disp_moji);					// \
				}
			}
		}
		uc = get_action_sw();									// XCb`Ԃ
		uc &= 0x0f;												// EXCb`ɂ
		if(uc != 0){											// ANVL鎞
			if(uc == SWR_OFF_SHORT){							// Zꂽ
				sel++;
				if(3 < sel){
					sel = 0;
				}
			}else if(uc == SWR_OFF_LONG){						// ꂽ
				if(sel == 0){
					led_ena_dis();								// kdcnm^neeݒ
				}else if(sel == 1){
					proc_set_hv_out();							// guo͒lݒ
				}else if(sel == 2){
					proc_set_cpm_uSv_span();					// rZl̑I
					proc_set_cpm_uSv_ofset();
				}else if(sel == 3){
					proc_set_eep_save_mode();					// ddoqnlۑ[h̑I
				}
				kesu = 1;
				disp_clear();									// Clear Display
				tim_10ms_ad0 = 0;
			}
		}
	}
}
//*****************************************
// ݒlύX or ۑf[^\AM̑I
//*****************************************
void	select_config_savedata(void)
{
	unsigned char	sel=0;										// 0:"Config", 1:"SaveData"
	unsigned char	kesu=1;
	unsigned char	uc;

	sei();														// 荞݉

	get_pgm_str(&str_config[0]);								// vÖ̕("Config")擾
	disp_lcd( 0,0,disp_moji);									// \
	get_pgm_str(&str_savedata[0]);								// vÖ̕("SaveData")擾
	disp_lcd( 0,1,disp_moji);									// \

	wait_key_off();												// Q̃XCb`Q@܂ŉiv[v

	tim_10ms_ad0 = 0;											// `^cOpPOrPʃ^C}[\Ԋuɗp
	while(1){
		if(tim_10ms_ad0 == 0){									// TOOr̕\i`^cOp^C}[pj
			tim_10ms_ad0 = 50;
			kesu ^= 1;											// I̓_
			if(kesu == 0){										// _ł̓_̎
				get_pgm_str(&str_config[0]);					// vÖ̕("Config")擾
				disp_lcd( 0,0,disp_moji);						// \
				get_pgm_str(&str_savedata[0]);					// vÖ̕("SaveData")擾
				disp_lcd( 0,1,disp_moji);						// \
			}else{												// _ł̖ł̎
				get_pgm_str(&str_space10[0]);					// vÖ̕("      ")擾
				if(sel == 0){
					disp_lcd(0,0, &disp_moji[0]);				// Xy[X\
					get_pgm_str(&str_savedata[0]);				// vÖ̕("SaveData")擾
					disp_lcd( 0,1,disp_moji);					// \
				}else{
					disp_lcd(0,1, &disp_moji[0]);				// Xy[X\
					get_pgm_str(&str_config[0]);					// vÖ̕("Config")擾
					disp_lcd( 0,0,disp_moji);						// \
				}
			}
		}
		uc = get_action_sw();									// XCb`Ԃ
		uc &= 0x0f;												// EXCb`ɂ
		if(uc != 0){											// ANVL鎞
			if(uc == SWR_OFF_SHORT){							// Zꂽ
				sel++;
				if(1 < sel){
					sel = 0;
				}
			}else if(uc == SWR_OFF_LONG){						// ꂽ
				if(sel == 0){
					select_led_hv_cpm();						// kdcAgu|ntsAor Zl̑I
				}else{
					proc_disp_trans();							// ۑf[^̕\ or M@I
				}
				kesu = 1;
				disp_clear();									// Clear Display
				tim_10ms_ad0 = 0;
			}
		}
	}
}
