//*****************************************
// AVR Geiger Counter mega168 Program
// CPU Clock:1MHz
//   iq[Yf[^@WāAOIV[^(8MHz)ɂj
// KCK[JE^[vO
//
// File Name:uart.c
//
//  2011/12/17 Taishi New
//  2012/ 3/23 Taishi Ver 1.30
//*****************************************

#include	<avr/io.h>

#include	"ATmega168_geiger.h"
#include	"uart.h"
#include	"timer.h"

// **********************************************************
// ************************** UART **************************
// **********************************************************
//***************************
// UART Initial
//***************************
void	uart_init(void)
{
#ifdef			UART_ARI										// VAʐML̎
	PRR &= ~(1 << PRUSART0);									// UART0 ғ
	delay_16us(100/16);											// POOr҂

	UBRR0  = BPS_9600;											// aor

	UCSR0C = (V_PARITY_NON | V_DATA_8);	// peBAf[^

	UCSR0A = V_UCSR0A;
	UCSR0B = V_UCSR0B;
#endif			//UART_ARI										// VAʐML̎

}
//***************************
// UART Close
//***************************
void	uart_close(void)
{
#ifdef			UART_ARI										// VAʐML̎
	PRR |= (1 << PRUSART0);										// ~
	delay_16us(100/16);											// POOr҂
#endif			//UART_ARI										// VAʐML̎

}
//***************************
// UART TxD One Char
//  荞݂gȂ
//***************************
void	uart_tx_one(unsigned char uc)
{
#ifdef			UART_ARI										// VAʐML̎
	while((UCSR0A & (1 << UDRE0)) == 0){
		;
	}
	UDR0 = uc;
#endif			//UART_ARI										// VAʐML̎
}
//***************************
// UART TxD String
//  荞݂gȂ
//***************************
void	uart_tx_str(char *str)
{
#ifdef			UART_ARI										// VAʐML̎
	while(*str != 0){
		uart_tx_one((unsigned char)(*str));
		str++;
	}
#endif			//UART_ARI										// VAʐML̎
}
//***************************
// UART TxD String + CR + LF
//***************************
void	uart_tx_str_crlf(char *str)
{
	uart_tx_str(str);											// UART TxD String
	uart_tx_one(0x0d);											// CR
	uart_tx_one(0x0a);											// LF
}

