//*****************************************
// AVR Geiger Counter mega168 Program
// CPU Clock:1MHz
//   iq[Yf[^@WāAOIV[^(8MHz)ɂj
// KCK[JE^[vO
//
// File Name:utl.c
//
//  2011/12/17 Taishi New
//  2012/ 3/23 Taishi Ver 1.30
//*****************************************

#include	"ATmega168_geiger.h"
#include	"utl.h"

// **********************************************************
// ************************ Utility *************************
// **********************************************************

/****************************************************************/
/* PoCgf[^										*/
/* PUîQ̂`rbhhɕϊ							*/
/* ʌ̂OTvX͂Ȃ									*/
/****************************************************************/
void	wtod_02x(char *bf,unsigned char ucd)
{
	*bf = (char)(((ucd>>4) & 0x0f)|'0');
	if (*bf > '9'){
		*bf += 7;
	}
	bf++;
	*bf = (char)(((ucd) & 0x0f)|'0');
	if (*bf > '9'){
		*bf += 7;
	}
	bf++;
	*bf=0;
}
/****************************************/
/* PoCgf[^				*/
/* Q̂POî`rbhhɕϊ	*/
/* ʌ̂OTvX͂Ȃ			*/
/****************************************/
void	wtod_02u(char *bf,unsigned char ucd)
{
	*bf = (char)('0'+(ucd/10));
	bf++;
	*bf = (char)('0'+(ucd%10));
	bf++;
	*bf=0;
}
/****************************************/
/* PoCgf[^				*/
/* Q̂POî`rbhhɕϊ	*/
/* ʌ̂OTvX				*/
/****************************************/
void	wtod_2u(char *bf,unsigned char ucd)
{
	*bf = (char)('0'+(ucd/10));
	if(*bf == '0'){
		*bf = ' ';
	}
	bf++;
	*bf = (char)('0'+(ucd%10));
	bf++;
	*bf=0;
}

/****************************************/
/* QoCgf[^				*/
/* T̂POî`rbhhɕϊ	*/
/* ʌ̂OTvX͂Ȃ			*/
/****************************************/
void	wtod_05u(char *bf,unsigned int usd)
{
	int				i;
	unsigned int	cui;

	cui = 10000;
	for(i=0;i<5;i++){
		*bf = (char)('0'+(usd/cui));
		usd %= cui;
		bf++;
		cui /= 10;
	}
	*bf=0;
}
/****************************************/
/* QoCgf[^				*/
/* T̂POî`rbhhɕϊ	*/
/* ʌ̂OTvX				*/
/****************************************/
void	wtod_5u(char *bf,unsigned int usd)
{
	int				i;
	char			*bfb;

	bfb = bf;
	wtod_05u(bf, usd);					// QoCgf[^T̂POî`rbhhɕϊ(ʌ̂OTvX͂Ȃ)
	for(i=0;i<4;i++,bfb++){
		if(*bfb == '0'){
			*bfb = ' ';
		}else{
			break;
		}
	}
}
//*****************************************
// (unsigned int)
// uc0: mDO̒l
// uc1: mDP̒l
// uc2: mDQ̒l
// def: SĈĂ Cl
//*****************************************
unsigned int	tasuuketu_ui(unsigned int ui0, unsigned int ui1, unsigned int ui2, unsigned int def)
{
	unsigned int	ui;

	if(ui0 == ui1){
		ui = ui0;
	}else if(ui0 == ui2){
		ui = ui0;
	}else if(ui1 == ui2){
		ui = ui1;
	}else{
		ui = def;
	}

	return(ui);
}
//*****************************************
// (unsigned char)
// uc0: mDO̒l
// uc1: mDP̒l
// uc2: mDQ̒l
// def: SĈĂ Cl
//*****************************************
unsigned char	tasuuketu_uc(unsigned char uc0, unsigned char uc1, unsigned char uc2, unsigned char def)
{
	unsigned char	uc;

	if(uc0 == uc1){
		uc = uc0;
	}else if(uc0 == uc2){
		uc = uc0;
	}else if(uc1 == uc2){
		uc = uc1;
	}else{
		uc = def;
	}

	return(uc);
}
